package arraybasedDS;

/**
 * @author Luca Castelli Aleardi
 * This interface provides all methods defined by a data structure
 * based on half edges for representing planar or surface meshes
 */
public interface HalfedgeInterface extends TriangulationInterface {

	public void setNext(int e, int eNext);
	public void setOpposite(int e, int eOpposite);
	public void setVertex(int e, int v);
	public void setEdge(int v, int e);
	public void setPoint(int v, float x, float y, float z);
	
	public int getNext(int e);
	public int getOpposite(int e);
	public int getPrev(int e);
	
	public int sizeOfVertices();
	public int sizeOfHalfedges();
	
}
