package arraybasedDS;

/**
 * @author Luca Castelli Aleardi
 * This interface provides all main methods supported by a triangle mesh
 * represented with an array based data structure
 */
public interface TriangulationInterface {

	/**
	 * Return the vertex origin of edge e
	 */
	public int getSource(int e);

	/**
	 * Return the vertex target of edge e
	 */
	public int getTarget(int e);
	
	/**
	 * Return an edge incident to vertex v
	 */
	public int getEdge(int v);
		
	/**
	 * Return the geometric coordinates of the point
	 */
	public float[] getPoint(int v);
	
	/**
	 * Return the number of vertices in the triangulation
	 */
	public int sizeOfVertices();

}
