package arrays;

/**
 * @author Luca Castelli Aleardi (Ecole Polytechnique, 2016)
 * 
 * This interfaces defines the Abstract Data Type (ADT) of a stack storing integer values
 */
public interface StackInterface {

	/**
	 * Pushes a value onto the top of this stack.
	 */
    public void push(int value);

	/**
	 * Removes the value at the top of this stack and returns that value as the value of this function.
	 */
    public int pop();

	/**
	 * Returns the value at the top of this stack (with deletion).
	 */
    public int top();

	/**
	 * Returns the numbers of elements in the stack.
	 */
    public int size();

	/**
	 * Reset the array: all elements are removed (set to 0)
	 */
    public void reset();

	/**
	 * Check whether the stack is empty
	 */
    public boolean isEmpty();

}
