package arrays.test;

import arrays.TableNoAdditionalServiceBits;

public class Test {
	
	/*public static boolean testEquality(ArrayWithServiceBits table, int[] t) {
		for(int i=0;i<t.length;i++)
			if(table.elementAt(i)!=t[i])
				return false;
		return true;
	}*/
	
	public static void showMemory() {
		Runtime runtime = Runtime.getRuntime();  
		  
		long maxMemory = runtime.maxMemory();  
		long allocatedMemory = runtime.totalMemory();  
		long freeMemory = runtime.freeMemory();  
		  
		System.out.print("free memory: " + freeMemory / 1024);  
		System.out.print(", allocated: " + allocatedMemory / 1024);  
		System.out.print(", max: " + maxMemory /1024);  
		System.out.println(", total free memory: " + (freeMemory + (maxMemory - allocatedMemory)) / 1024);	
	}

	public static void benchmarkArrays(int n) {
		
		long time0=System.currentTimeMillis();

		//ArrayWithServiceBits table=new TableNoAdditionalServiceBits(n);
		//ArrayWithServiceBits table=new TableWithAdditionalServiceBits(n);
		//ReferenceArray table=new Table(n);
		
		
		//int[] intT=new int[n];
		//byte[] byteT=new byte[n];
		long[] longT=new long[n];
		int repeat=50;
		
		// writing
		for(int j=0;j<repeat;j++) {
			for(int i=0;i<n;i++) {
				//table.set(i, i);
				//table.setFirstServiceBit(i);

				//intT[i]=10;
				//byteT[i]=10;
				longT[i]=i+2458787874983L;
			}
		}
		long time1=System.currentTimeMillis();

		// reading
		int v;
		byte byteV;
		boolean value;
		long longV;
		for(int j=0;j<repeat;j++) {
			for(int i=0;i<n;i++) {
				//v=table.elementAt(i);
				//v=table.getFirstServiceBit(i);

				//v=intT[i];
				//byteV=byteT[i];
				longV=longT[i];
			}
		}

		long time2=System.currentTimeMillis();
		System.out.println("time: "+((time1-time0)/1000.)/repeat);
		System.out.println("time: "+((time2-time1)/1000.)/repeat);
		System.out.println("test done");
	}

	static int logBase2(int n) {
		double a=(double)n;
		return (int)((Math.log10(a))/Math.log10(2.));
	}
	
	public static void correctnessArrays() {
		System.out.println("Testing Array coorectness");	
		int n=1000000; // java -Xms5m -Xmx15m MyApp 
		// ArrayWithServiceBits t=new TableWithAdditionalServiceBits(n);
		TableNoAdditionalServiceBits table=new TableNoAdditionalServiceBits(n);
		//int[] t=new int[n];
		for(int i=0;i<n;i++) {
			table.set(i, i);
			//t[i]=i;
			
			if(i%3==0)
				table.setFirstServiceBit(i);
			if(i%4==0)
				table.setSecondServiceBit(i);
		}
		// System.out.println("Array "+table);
		//System.out.println("arrays are equal: "+testEquality(table, t));
		System.out.println("reference size: "+logBase2(n));
		System.out.println("test done");
	}

	public static void benchmark(int n, int k) {
		  System.out.println("Comparing BitSet implementations");
		  System.out.println("test done");
		
	}
	
	public static String booleanToString(boolean[] t) {
		String res="";
		for(int i=0;i<t.length;i++) {
			if(t[i])
				res=res+1;
			else
				res=res+0;
		}
		return res;
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		int n=1000000; // 10^6

		//showMemory();
		//int[] intTable=new int[n];
		//long[] longTable=new long[n];
		//byte[] byteTable=new  byte[n];
		//float[] floatTable=new float[n];
		//double[] doubleTable=new double[n];
		//showMemory();

		benchmarkArrays(n);
		correctnessArrays();
	}

}
