package arrays.test;

import arrays.TableWithTwoServiceBits;

public class TestArrayWithServiceBits {

	public static void testTable(int n) {
		System.out.println("Testing table with 2 service bits (implemented via shift and mask operations");
		TableWithTwoServiceBits t=new TableWithTwoServiceBits(n);
		
		for(int i=0;i<n;i++) {
			t.set(i, i);
			if(i%2==1)
				t.setFirstServiceBit(i);
			t.setSecondServiceBit(i);
		}
		
		for(int i=0;i<n;i++)
			System.out.println(t.elementToString(i));
	}

	public static void testReferenceAndBitsManipulation(int n, int maxRange) {
		System.out.println("Testing manipulation of bits and references");
		TableWithTwoServiceBits t=new TableWithTwoServiceBits(n);
		
		for(int i=0;i<n;i++) {
			int reference=(int)(Math.random()*maxRange); // a random integer value in [0..maxRange-1]
			int serviceBits=(int)(Math.random()*4); // a random integer value in [0..3]
			System.out.print("("+reference+","+serviceBits+")");
			
			int v=TableWithTwoServiceBits.storeReferenceAndServiceBitsIntoInteger(reference,  serviceBits);
			
			int extractRef=TableWithTwoServiceBits.extractReferenceFromInteger(v);
			int extractBits=TableWithTwoServiceBits.extractTwoServiceBitsFromInteger(v);
			
			System.out.print(" ---> ("+extractRef+","+extractBits+")");
			System.out.println();
		}
		
	}
	
	public static void main(String[] args) {
		//testTable(100);
		testReferenceAndBitsManipulation(100, 10000);
	}

}
